xine-lib: xine-lib-1.2.13/src/demuxers/demux_realaudio.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions
demux_realaudio.c File Reference
`#include <stdio.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include <ctype.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/demux.h>`
`#include <xine/buffer.h>`
`#include "bswap.h"`
`#include "group_audio.h"`
`#include "demux_real_common.h"`

## Data Structures
struct | demux_ra_t

## Macros
#define | RA_FILE_HEADER_PREV_SIZE 22

## Functions
static int | open_ra_file (demux_ra_t *this)
static int | demux_ra_send_chunk (demux_plugin_t *this_gen)
static void | demux_ra_send_headers (demux_plugin_t *this_gen)
static int | demux_ra_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static void | demux_ra_dispose (demux_plugin_t *this_gen)
static int | demux_ra_get_status (demux_plugin_t *this_gen)
static int | demux_ra_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_ra_get_capabilities (demux_plugin_t *this_gen)
static int | demux_ra_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
void * | demux_realaudio_init_plugin (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ RA_FILE_HEADER_PREV_SIZE

#define RA_FILE_HEADER_PREV_SIZE 22

Referenced by open_ra_file().

## Function Documentation

## ◆ demux_ra_dispose()

static void demux_ra_dispose | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_ra_get_capabilities()

static uint32_t demux_ra_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_ra_get_optional_data()

static int demux_ra_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_ra_get_status()

static int demux_ra_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_ra_get_stream_length()

static int demux_ra_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_ra_seek()

static int demux_ra_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References _x_demux_flush_engine(), DEMUX_FINISHED, DEMUX_OK, input(), and INPUT_IS_SEEKABLE.

Referenced by open_plugin().

## ◆ demux_ra_send_chunk()

static int demux_ra_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_newpts(), _x_demux_read_send_data(), _x_demux_send_data(), BUF_AUDIO_28_8, BUF_AUDIO_SIPRO, BUF_FLAG_SEEK, DEMUX_FINISHED, demux_real_sipro_swap(), input(), XINE_VERBOSITY_DEBUG, and xprintf.

Referenced by open_plugin().

## ◆ demux_ra_send_headers()

static void demux_ra_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), BUF_FLAG_FRAME_END, BUF_FLAG_HEADER, buf_element_s::content, buf_element_s::decoder_flags, DEMUX_OK, fourcc, buf_element_s::max_size, MIN, buf_element_s::size, buf_element_s::type, XINE_STREAM_INFO_AUDIO_FOURCC, XINE_STREAM_INFO_HAS_AUDIO, and XINE_STREAM_INFO_HAS_VIDEO.

Referenced by open_plugin().

## ◆ demux_realaudio_init_plugin()

void * demux_realaudio_init_plugin | ( | xine_t * | xine,
|  | const void * | data )

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References xine_stream_s::content_detection_method, DEMUX_FINISHED, demux_ra_dispose(), demux_ra_get_capabilities(), demux_ra_get_optional_data(), demux_ra_get_status(), demux_ra_get_stream_length(), demux_ra_seek(), demux_ra_send_chunk(), demux_ra_send_headers(), input(), METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, open_ra_file(), and input_plugin_s::seek.

Referenced by demux_realaudio_init_plugin().

## ◆ open_ra_file()

static int open_ra_file | ( | demux_ra_t * | this | ) |
| static

References _X_BE_16, _X_BE_32, _x_demux_read_header(), _x_formattag_to_buf_audio(), _X_ME_32, _x_meta_info_n_set(), _x_stream_info_set(), BUF_AUDIO_28_8, BUF_AUDIO_SIPRO, BUF_AUDIO_UNKNOWN, fourcc, input(), ME_FOURCC, RA_FILE_HEADER_PREV_SIZE, XINE_META_INFO_ARTIST, XINE_META_INFO_TITLE, XINE_META_INFO_YEAR, XINE_STREAM_INFO_AUDIO_FOURCC, XINE_VERBOSITY_DEBUG, and xprintf.

Referenced by open_plugin().